package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.FiscalImpressoraEstadoDAO;
import com.rjconsultores.ventaboletos.entidad.FiscalImpressora;
import com.rjconsultores.ventaboletos.entidad.FiscalImpressoraEstado;

@Repository("fiscalImpressoraEstadoDAO")
public class FiscalImpressoraEstadoHibernateDAO extends GenericHibernateDAO<FiscalImpressoraEstado, Integer> implements FiscalImpressoraEstadoDAO {

	@Autowired
	public FiscalImpressoraEstadoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}
	
	@Override
	public List<FiscalImpressoraEstado> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("estado.nombestado"));

		return c.list();
	}
	
	public List<FiscalImpressoraEstado> retornaEstadosFiscalImpressora(FiscalImpressora fiscalImpressora) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("fiscalImpressora", fiscalImpressora));

		return c.list();
	}
	
}
